import java.util.*;
import java.io.*;
import javax.swing.filechooser.*;

public class ManageDrive {
	StringTokenizer st;
	
    String log;
    String msg = "" ;
	
   //Drive List.
    public String driveList() {   	     
	   
	    String Label;
						
	    FileSystemView fsv = FileSystemView.getFileSystemView();
						
        File[] roots ;
		roots = File.listRoots();
			
		msg = "" ;
			
		for (int i = 0; i < roots.length ; i++) {
            msg += roots[i] + "$$";
		}
			
		return msg; 
	}

	public String directoryList(String dirName) {
		String[] files ; 
		msg = "" ;
		dirName = dirName.replace('*', ' ') ;
		//System.out.println(dirName) ;
		 
		if (dirName == "desktop") {
			FileSystemView fsv = FileSystemView.getFileSystemView();
			File HomeDir = fsv.getHomeDirectory();
			
			files = HomeDir.list();
			System.out.println(HomeDir);
			dirName = HomeDir.getAbsolutePath();
			msg = dirName +"**";
		}
		else {
			File path = new File(dirName);
			files = path.list();
		}
		
		System.out.println("Total Files in the Current Directory : " + files.length);
		if ( files != null ) 
		{
			for (int i = 0 ; i < files.length ; i++) {
				File f2 = new File(dirName+"/"+files[i]);
				if(f2.isDirectory()) {
					msg += "?"+files[i]+"$$";
					//System.out.println("*"+files[i]+"*");
				}
				else {
					msg += files[i]+"$$";
					//System.out.println("\t"+files[i]);
				}
			}
		}
		else
			msg = dirName + "**" ;
		System.out.println(msg) ;
		return msg;	
	}
	
	public String delFile(String dirPath) {
		boolean success = (new File(dirPath)).delete();
		if (success) {
			// Deletion successful
			log = "File Successfully Deleted ..@"+new Date();
			System.out.println(log);
		} 
		else {
			log = "File deletion error ..@"+new Date();
			System.out.println(log);
		}
		return log;
	}
	
	public boolean delDir(File dir) {
        if (dir.isDirectory()) {
            String[] children = dir.list();
            for (int i=0; i<children.length; i++) {
                boolean success = delDir(new File(dir, children[i]));
                if (!success) {
                    return false;
                }
            }
        }
    
        // The directory is now empty so delete it
        return dir.delete();
    }
	
	public String renameFileDir(String oldName,String newName) {
		// File (or directory) with old name
		File file = new File(oldName);
    
		// File (or directory) with new name
		File file2 = new File(newName);
    
		// Rename file (or directory)
		boolean success = file.renameTo(file2);
        if (success) {
			// Deletion successful
			log = "File/Directory Successfully renamed..@";
			System.out.println(log);
		} 
		else {
			log = "File/Directory renaming error ..@";
			System.out.println(log);
		}
		return log;
    }
	/*
	public String newFile(String path,String text) {
		try {
			File file = new File(path);
    
			// Create file if it does not exist
			boolean success = file.createNewFile();
			if (success) {
				// File did not exist and was created
				log = "File successfully created..@";
			} 
			else {
				// File already exists
				log = "File Name already exits..@";
			}
			// writing to the file
			System.out.println(log);
			try {
				BufferedWriter out = new BufferedWriter(new FileWriter(path));
				out.write(text);
				out.close();
				log = "File successfully saved..@";
				System.out.println(log);
			}
			catch (IOException e) {
				
				log = "Error writing file to disk..@";
				System.out.println(log);
			}
			
		} 
		catch (IOException e) {
			
			log = "Error creating file..@";
			System.out.println(log);
			return log;
					
		}
		
		return log;
	} */
	
	public String newDir(String path) {
		// Create a directory; all ancestor directories must exist
		boolean success = (new File(path)).mkdir();
		if (success) {
			// File did not exist and was created
			log = "Directory successfully created..@";
		} 
		else {
			// File already exists
			log = "Error ! Directory already exists..@";
		}
		return log;
    }
	
	public String copyFileDir(File srcDir,File dstDir) throws IOException {
		// Copies all files under srcDir to dstDir.
		// If dstDir does not exist, it will be created.
        if (srcDir.isDirectory()) {
			System.out.println("Is Directory") ;
			if (!dstDir.exists()) {
                dstDir.mkdir();
            }
            String[] children = srcDir.list();
            for (int i=0; i<children.length; i++) {
                copyFileDir(new File(srcDir, children[i]),new File(dstDir, children[i]));
            }
			log = "Directory successfully copied..@";
        } else {
            // Copies src file to dst file.
			// If the dst file does not exist, it is created
			InputStream in = new FileInputStream(srcDir);
			OutputStream out = new FileOutputStream(dstDir);
    
			// Transfer bytes from in to out
			byte[] buf = new byte[1024];
			int len;
			while ((len = in.read(buf)) > 0) {
				out.write(buf, 0, len);
			}
			in.close();
			out.close();
			log ="File successfully copied..@";
		}
		System.out.println(log);
		
        return log;
    }
	
	public String cutFileDir(String src,String dst) {
		// File (or directory) to be moved
		File file = new File(src);
    
		// Destination directory
		File dir = new File(dst);
    
		// Move file to new directory
		boolean success = file.renameTo(new File(dir, file.getName()));
		if (success) {
			// File did not exist and was created
			if(file.isDirectory()) {
				log = "Directory successfully moved..@";
			
			}
			else {
				log = "File successfully moved..@";
			}
		} 
		else {
			// File already exists
			log = "Error ! File/Directory cannot be moved..@";
		}
		System.out.println(log);
		
		return log;
    }
	
	 public static long getFileDirSize(File file) {
        long size = 0;
        if(file.isDirectory()) {
            File[] files = file.listFiles();
            if(files != null) {
                for(int i = 0; i < files.length; i++) {
                    long tmpSize = getFileDirSize(files[i]);
                    if(tmpSize != -1) {
                        size += tmpSize;
                    }
                }
                return size;
            }
            return -1;
        }
        return file.length();
    }		
}