#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <psapi.h>
#include "ProcessList.h"


JNIEXPORT jobjectArray JNICALL Java_ProcessList_processList(JNIEnv *env, jobject) {

	DWORD ProcessesIDs[50], cbNeeded, cProcesses; 
	PROCESS_MEMORY_COUNTERS pmc;
	unsigned int i; 
	
	
	jobjectArray obj ;
	jclass cls;
	
	
	//The default process name is <unknown> 
	
	TCHAR ProcessName[50] = TEXT("<unknown>");

	//if Enumprocess returns zero then quit the program.

	if ( !EnumProcesses( ProcessesIDs, sizeof(ProcessesIDs), &cbNeeded ) )
		return 0; 

	// Calculate how many process identifiers(PID) were returned.

	cProcesses = cbNeeded / sizeof(DWORD);
	
	// initializing the return object
	
	cls=(*env).FindClass("java/lang/String");
	obj=(*env).NewObjectArray(cProcesses,cls,0);
	
	
	//_tprintf(TEXT("Total active processes in the system : %u\n"),cProcesses);

	// This for loop will be enumerating each process. (Name,Memory Usage)

	for ( i = 0; i < cProcesses; i++ )
	{
		// Get a handle to the process. 
    
		HANDLE hProcess = OpenProcess( PROCESS_QUERY_INFORMATION | PROCESS_VM_READ, FALSE, ProcessesIDs[i] );

		// Get the process name.
		if (NULL != hProcess )
        {
			GetModuleBaseName( hProcess, NULL, ProcessName, sizeof(ProcessName)/sizeof(TCHAR) );
        }
		
		//Building the return object Array
	
				
		// Print the process name and identifier.
	
		//_tprintf(TEXT("Processname = %s, PID = %u "), ProcessName, ProcessesIDs[i]);
    
		// Print the process Memory Usage
		char *a;
		if ( GetProcessMemoryInfo( hProcess, &pmc, sizeof(pmc)) )
		{
			//printf( "\tPageFaultCount: 0x%08X\n", pmc.PageFaultCount );
		
			//printf( "\tPhysical Memory: %dKB\n\n", pmc.WorkingSetSize/1000 );
			char buff[35];
			int j = (int)pmc.WorkingSetSize/1000 ; 
			a = _itoa(j,buff,10);
        }
		else 
		{
			//printf("\n\n");
		}
		
		TCHAR output[100];
		_stprintf(output,_T("%s*%sKB"),ProcessName,a); 
		//printf("%s\n",output);
		{
				env->SetObjectArrayElement(obj,i,env->NewStringUTF(output));	 
		}

    
		//Every handel is to be closed after its use is over.
			CloseHandle( hProcess );
		//End of for loop.
    }
	
	return obj;
	}